Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ComparisonTerminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ComparisonTerminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ComparisonTerminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ExecutionTimeTerminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ExecutionTimeTerminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ExecutionTimeTerminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/SingleObjectiveQualityTerminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/SingleObjectiveQualityTerminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/SingleObjectiveQualityTerminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/TerminationOperator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/TerminationOperator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/TerminationOperator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/Terminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/Terminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/Terminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ThresholdTerminator.cs
===================================================================
--- branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ThresholdTerminator.cs	(revision 15689)
+++ branches/2457_ExpertSystem/HeuristicLab.Optimization/3.3/Termination/ThresholdTerminator.cs	(revision 16075)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.